type PromiseResolver = (resolver: () => void, reject: (err?: Error) => void) => void

export interface PromiseQueue {
  public static next(promiseResolver: PromiseResolver): Promise

  private queue: Promise[]
  private current: Promise

  public next(promiseResolver: PromiseResolver): Promise
}